using System;
using System.Collections.Generic;
using System.Text;
using System.Collections;
using System.Collections.ObjectModel;

namespace PocketRassegnaRAI
{
    /// <summary>
    /// contiene un elenco dei valori di un combobox in coppia ID-Desc
    /// </summary>
    public class CComboData
    {
        private int _intID;
        public int ID
        {
            get { return _intID; }
            set { _intID = value; }
        }

        private string _strDesc;
        public string Desc
        {
            get { return _strDesc; }
            set { _strDesc = value; }
        }

        public CComboData(){}
        public CComboData(int intID, string strDesc)
        {
            _intID = intID;
            _strDesc = strDesc;
        }
    }

    /// <summary>
    /// Contiene tutte le impostazioni del programma che andranno lette/scritte in un file
    /// XML da una classe apposita
    /// </summary>
    public class CSettings
    {
        //primo livello di selezione del file (RaiNet, RaiSat ecc)
        private List<CComboData> _lstLevel1Items;
        public List<CComboData> Level1Items
        {
            get { return _lstLevel1Items; }
            set { _lstLevel1Items = value; }
        }

        //titolo del box con la scelta del primo livello di selezione
        private string _strLevel1Title;
        public string Level1Title
        {
            get { return _strLevel1Title; }
            set { _strLevel1Title = value; }
        }

        //secondo livello di selezione del file (lunedi', martedi' ecc)
        private List<CComboData> _lstLevel2Items;
        public List<CComboData> Level2Items
        {
            get { return _lstLevel2Items; }
            set { _lstLevel2Items = value; }
        }

        //titolo del box con la scelta del primo livello di selezione
        private string _strLevel2Title;
        public string Level2Title
        {
            get { return _strLevel2Title; }
            set { _strLevel2Title = value; }
        }

        //elenco dei file da scaricare, in un formato adatto alla serializzazione
        private List<string>_lstFilesToDownload;
        //elenco dei file da scaricare, in un formato adatto alla consultazione
        public List<string>FilesToDownload
        {
            get { return _lstFilesToDownload; }
            set { _lstFilesToDownload = value; }
        }

        //separatore negli elementi della lista dei file da scaricare, tra gli indici e il nome del file
        private string _strSeparatorChar;
        public string SeparatorChar
        {
            get { return _strSeparatorChar; }
            set { _strSeparatorChar = value; }
        }

        //url di base da dove scaricare il file
        private String _strBaseURL;
        public String BaseURL
        {
            get { return _strBaseURL; }
            set { _strBaseURL = value; }
        }

        //percorso dove appoggiare i file scaricati
        private string _strCachePath;
        public string CachePath
        {
            get { return _strCachePath; }
            set { _strCachePath = value; }
        }

        //path del programma per leggere i pdf
        private string _strPDFAppPath;
        public string PDFAppPath
        {
            get { return _strPDFAppPath; }
            set { _strPDFAppPath = value; }
        }

        //identificatore univoco dell'istanza del programma
        private string _strProgUniqueID;
        public string ProgUniqueID
        {
            get { return _strProgUniqueID; }
            set { _strProgUniqueID = value; }
        }
	
	
        ///ctor Necessario per la deserializzazione
        public CSettings()
        {
            _lstLevel1Items = new List<CComboData>();
            _lstLevel2Items = new List<CComboData>();
            _lstFilesToDownload = new List<string>();
        }
    }
}
