using System;
using System.IO;
using System.Reflection;
using System.Data;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace PocketRassegnaRAI
{
	/// <summary>
	/// Summary description for FileSelectDlg.
	/// </summary>
	public class frmFileSelect2 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.ListView listView1;
		private System.Windows.Forms.TreeView treeView1;
		private System.Windows.Forms.ColumnHeader columnHeader1;
		private System.Windows.Forms.ColumnHeader columnHeader2;
		private System.Windows.Forms.ToolBar toolBar1;
		private System.Windows.Forms.ToolBarButton tbBtnCancel;
		private System.Windows.Forms.ToolBarButton tbBtnTreeView;
		private System.Windows.Forms.ToolBarButton tbBtnFileView;
        private System.Windows.Forms.ToolBarButton tbBtnSplitView;
		private System.Windows.Forms.ToolBarButton tbBtnOk;

		private string		m_Mask;
		private Rectangle	m_rectTree;
        private Rectangle m_rectFiles;				
		public string	FileName;
	
		public frmFileSelect2(string Mask)
		{
			m_Mask=Mask;
			DialogResult=DialogResult.Cancel;
			Init();
			InitImageList();
		}

		public frmFileSelect2()
		{
			m_Mask="*.*";
			Init();
		}

		public void Init()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			m_rectTree=new Rectangle(treeView1.Left,treeView1.Top,treeView1.Width,treeView1.Height);
			m_rectFiles=new Rectangle(listView1.Left,listView1.Top,listView1.Width,listView1.Height);

			FillTree();
			tbBtnOk.Enabled=false;
		}

		private Icon GetIcon(string name) 
		{
			Assembly execAssembly= Assembly.GetExecutingAssembly();
			string []ResNames=execAssembly.GetManifestResourceNames();
			string ResName=execAssembly.GetName().Name + "." + name + ".ico";
			Stream stream = execAssembly.GetManifestResourceStream(ResName);
			return new Icon(stream);
		}

		private void ExpandNode(TreeNodeCollection ParentNode, string RootDir)
		{
			DirectoryInfo DI=new DirectoryInfo(RootDir);
			DirectoryInfo []Dirs=DI.GetDirectories();			

			// Sort Dirs
			ArrayList DirSorted=new ArrayList(Dirs.Length);			
			foreach(DirectoryInfo DI1 in Dirs)
			{
				DirSorted.Add(DI1);
			}
			DirSorted.Sort(new myDirSort());

			foreach(DirectoryInfo DI2 in DirSorted)
			{
				TreeNode tn=new TreeNode(DI2.Name);
				tn.Tag=DI2.FullName;	
				tn.ImageIndex=6;
				tn.SelectedImageIndex=5;
				ParentNode.Add(tn);
				ExpandNode(tn.Nodes,DI2.FullName);
			}
		}

		private void FillTree()
		{
			treeView1.Nodes.Clear();
			Cursor.Current=Cursors.WaitCursor;
			ExpandNode(treeView1.Nodes,@"\");
			Cursor.Current=Cursors.Default;
			treeView1.SelectedNode=treeView1.Nodes[0];
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(frmFileSelect2));
            this.listView1 = new System.Windows.Forms.ListView();
            this.columnHeader1 = new System.Windows.Forms.ColumnHeader();
            this.columnHeader2 = new System.Windows.Forms.ColumnHeader();
            this.treeView1 = new System.Windows.Forms.TreeView();
            this.toolBar1 = new System.Windows.Forms.ToolBar();
            this.tbBtnOk = new System.Windows.Forms.ToolBarButton();
            this.tbBtnCancel = new System.Windows.Forms.ToolBarButton();
            this.tbBtnTreeView = new System.Windows.Forms.ToolBarButton();
            this.tbBtnFileView = new System.Windows.Forms.ToolBarButton();
            this.tbBtnSplitView = new System.Windows.Forms.ToolBarButton();
            this.SuspendLayout();
            // 
            // listView1
            // 
            this.listView1.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.listView1.Columns.Add(this.columnHeader1);
            this.listView1.Columns.Add(this.columnHeader2);
            this.listView1.FullRowSelect = true;
            this.listView1.HeaderStyle = System.Windows.Forms.ColumnHeaderStyle.Nonclickable;
            this.listView1.Location = new System.Drawing.Point(0, 136);
            this.listView1.Name = "listView1";
            this.listView1.Size = new System.Drawing.Size(240, 128);
            this.listView1.TabIndex = 1;
            this.listView1.View = System.Windows.Forms.View.Details;
            this.listView1.ItemActivate += new System.EventHandler(this.listView1_ItemActivate);
            this.listView1.SelectedIndexChanged += new System.EventHandler(this.listView1_SelectedIndexChanged);
            // 
            // columnHeader1
            // 
            this.columnHeader1.Text = "Name";
            this.columnHeader1.Width = 180;
            // 
            // columnHeader2
            // 
            this.columnHeader2.Text = "Size";
            this.columnHeader2.Width = 60;
            // 
            // treeView1
            // 
            this.treeView1.Dock = System.Windows.Forms.DockStyle.Top;
            this.treeView1.Location = new System.Drawing.Point(0, 0);
            this.treeView1.Name = "treeView1";
            this.treeView1.Size = new System.Drawing.Size(240, 136);
            this.treeView1.TabIndex = 0;
            this.treeView1.AfterSelect += new System.Windows.Forms.TreeViewEventHandler(this.treeView1_AfterSelect);
            // 
            // toolBar1
            // 
            this.toolBar1.Buttons.Add(this.tbBtnOk);
            this.toolBar1.Buttons.Add(this.tbBtnCancel);
            this.toolBar1.Buttons.Add(this.tbBtnTreeView);
            this.toolBar1.Buttons.Add(this.tbBtnFileView);
            this.toolBar1.Buttons.Add(this.tbBtnSplitView);
            this.toolBar1.Name = "toolBar1";
            this.toolBar1.ButtonClick += new System.Windows.Forms.ToolBarButtonClickEventHandler(this.toolBar1_ButtonClick);
            // 
            // tbBtnOk
            // 
            this.tbBtnOk.ImageIndex = 0;
            // 
            // tbBtnCancel
            // 
            this.tbBtnCancel.ImageIndex = 1;
            // 
            // tbBtnTreeView
            // 
            this.tbBtnTreeView.ImageIndex = 2;
            // 
            // tbBtnFileView
            // 
            this.tbBtnFileView.ImageIndex = 3;
            // 
            // tbBtnSplitView
            // 
            this.tbBtnSplitView.ImageIndex = 4;
            // 
            // frmFileSelect2
            // 
            this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Inherit;
            this.ClientSize = new System.Drawing.Size(240, 268);
            this.ControlBox = false;
            this.Controls.Add(this.treeView1);
            this.Controls.Add(this.listView1);
            this.Controls.Add(this.toolBar1);
            this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
            this.MaximizeBox = false;
            this.MinimizeBox = false;
            this.Name = "frmFileSelect2";
            this.Text = "Scegli l\'applicazione";
            this.ResumeLayout(false);

		}
		#endregion

		private void treeView1_AfterSelect(object sender, System.Windows.Forms.TreeViewEventArgs e)
		{
			listView1.Items.Clear();
			DirectoryInfo DI=new DirectoryInfo((string)e.Node.Tag);
			FileInfo []Files=DI.GetFiles(m_Mask);
			ArrayList FileSorted=new ArrayList(Files.Length);
			foreach(FileInfo FI1 in Files)
			{
				FileSorted.Add(FI1);
			}
			FileSorted.Sort(new myFileSort());

			foreach(FileInfo FI2 in FileSorted)
			{
				ListViewItem Item=new ListViewItem(FI2.Name);
				double Len=(double)FI2.Length;
				string Suffix="b";
				if (Len>(double)1024.0)
				{
					Len/=(double)1024.0;
					Suffix="Kb";
				}
				if (Len>(double)1024.0)
				{
					Len/=(double)1024.0;
					Suffix="Mb";
				}				
				Item.SubItems.Add(Len.ToString("0.##")+Suffix);
				Item.SubItems.Add(FI2.CreationTime.ToString());
				listView1.Items.Add(Item);
			}
		}

		private void toolBar1_ButtonClick(object sender, System.Windows.Forms.ToolBarButtonClickEventArgs e)
		{
			if (e.Button==tbBtnOk)
			{
				if (listView1.SelectedIndices.Count!=1)
					return;
			
				FileName=treeView1.SelectedNode.Tag+@"\"+listView1.Items[listView1.SelectedIndices[0]].Text;
				DialogResult=DialogResult.OK;
				Close();
			}
			if (e.Button==tbBtnCancel)
			{
				DialogResult=DialogResult.Cancel;
				Close();
			}
			if (e.Button==tbBtnTreeView)
			{
				treeView1.Height=this.Height;
				listView1.Hide();
				treeView1.Show();
				this.Refresh();
			}			
			if (e.Button==tbBtnFileView)
			{
				listView1.Top=m_rectTree.Top;
				listView1.Height=this.Height;
				treeView1.Hide();
				listView1.Show();
				this.Refresh();
			}
			if (e.Button==tbBtnSplitView)
			{
				treeView1.Top=m_rectTree.Top;
				treeView1.Left=m_rectTree.Left;
				treeView1.Height=m_rectTree.Height;
				listView1.Top=m_rectFiles.Top;
				listView1.Left=m_rectFiles.Left;
				listView1.Height=m_rectFiles.Height;								
				treeView1.Show();
				listView1.Show();
				this.Refresh();
			}
		}

		private void listView1_ItemActivate(object sender, System.EventArgs e)
		{
			tbBtnOk.Enabled=true;
		}

		private void listView1_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			if (listView1.SelectedIndices.Count==1)
				tbBtnOk.Enabled=true;
			else
				tbBtnOk.Enabled=false;
		}
	}

	public class myDirSort : IComparer  
	{
		// Calls CaseInsensitiveComparer.Compare with the parameters reversed.
		int IComparer.Compare(Object ax, Object ay )  
		{
			DirectoryInfo x=(DirectoryInfo)ax;
			DirectoryInfo y=(DirectoryInfo)ay;
			return x.Name.CompareTo(y.Name);
		}
	}
	public class myFileSort : IComparer  
	{
		// Calls CaseInsensitiveComparer.Compare with the parameters reversed.
		int IComparer.Compare(Object ax, Object ay )  
		{
			FileInfo x=(FileInfo)ax;
			FileInfo y=(FileInfo)ay;
			return x.Name.CompareTo(y.Name);
		}
	}

}
